/*
 * GETPARAM.H: command-line processing definitions
 *
 * Mar. 1987  Joshua Edward Barnes, Princeton NJ.
 * Sep. 1990  -- added finiparam() to list              PJT
 * Nov. 1991  -- added hasvalue()                       PJT
 * July 1993 -- C++ entrant
 * Mar  1994 -- added nemoinpf/r
 * Feb  1995 -- added updparam, no more ARGS
 */

#ifndef _getparam_h
#define _getparam_h

#ifdef __cplusplus
extern "C" {
#endif

void    initparam (string *, string *);
void    finiparam (void);
void    stop (int);
void	putparam (string, string);
void	promptparam (string, string);
bool    isaparam (string);
bool    hasvalue (string);
bool	updparam (string);
string  getparam  (string);
int     getiparam (string);
long    getlparam (string);
bool    getbparam (string);
double  getdparam (string);

int nemoinpi (string, int *, int);
int nemoinpd (string, double *, int);
int nemoinpf (string, float *, int);
int nemoinpl (string, long *, int);
int nemoinpb (string, bool *, int);

#if !defined(SINGLEPREC)
# define nemoinpr  nemoinpd
# define getrparam getdparam
#else
# define nemoinpr  nemoinpf
# define getrparam getfparam
#endif

#ifdef __cplusplus
}
#endif

/*
 * Macro used to obtain name of program.
 */

#define getargv0()      (getparam("argv0"))

#endif /* _getparam_h */
